#include ADOVFP.H

* Create the Connection object and open the Northwind database.

oConn = createobject('ADODB.Connection')
oConn.Open('Provider=Microsoft.Jet.OLEDB.4.0;' + ;
	'Data Source=D:\Program Files\Microsoft Visual Studio\VB98\Nwind.mdb')

* Create the Command object and define the command type and connection.

oCommand = createobject('ADODB.Command')
oCommand.CommandType = adCmdText
oCommand.ActiveConnection = oConn

* Execute a command.

oCommand.CommandText = "update customers " + ;
	"set country = 'England' " + ;
	"where country = 'UK'"
oCommand.Execute()

* Now do a parameterized query to see if it worked.

oParameter = oCommand.CreateParameter('Country', adChar, adParamInput, 15)
oCommand.Parameters.Append(oParameter)
oParameter.Value = 'UK'
oCommand.CommandText = 'select * from customers where country = ?'
oRS = oCommand.Execute()
wait window 'There are ' + iif(oRS.EOF, 'no', 'still some') + ' UK records'
oParameter.Value = 'England'
oRS = oCommand.Execute()
wait window 'There are ' + iif(oRS.EOF, 'no', 'some') + ' England records'

* Use the Command object in the Open method of a RecordSet object so we can
* control the RecordSet's attributes.

oRS = createobject('ADODB.RecordSet')
oRS.CursorLocation = adUseClient
oRS.CursorType = adOpenStatic
oRS.Open(oCommand)
wait window 'There are ' + transform(oRS.RecordCount) + ' records in the recordset'

* Let's undo the change we did.

oCommand.CommandText = "update customers " + ;
	"set country = 'UK' " + ;
	"where country = 'England'"
oCommand.Execute()

* Cleanup before we exit.

oRS.Close()
oConn.Close()
