#include ADOVFP.H
local oConn, ;
	oRS, ;
	laArray[1]

* Create a Connection object and open the Northwind database.

oConn = createobject('ADODB.Connection')
oConn.Open('Provider=Microsoft.Jet.OLEDB.4.0;' + ;
	'Data Source=D:\Program Files\Microsoft Visual Studio\VB98\Nwind.mdb')

* Create a RecordSet object and open a client-side cursor of customer records.

oRS = createobject('ADODB.RecordSet')
oRS.CursorLocation = adUseClient
oRS.Open('select * from customers', oConn)

* Convert the recordset into an array.

laArray = oRS.GetRows()

* Because the array returned by GetRows is in column-major rather than row-
* major order, let's flip it around.

FlipArray(@laArray)

* Display it.

clear
lnRows = alen(laArray, 1)
lnCols = alen(laArray, 2)
for lnRow = 1 to lnRows
	for lnCol = 1 to lnCols
		?? laArray[lnRow, lnCol], ' '
	next lnCol
	?
next lnRow
wait

* Now filter and sort the recordset and convert it into an array again.

oRS.Filter = "country = 'Canada'"
oRS.Sort = 'city'
laArray = oRS.GetRows()
FlipArray(@laArray)
clear
lnRows = alen(laArray, 1)
lnCols = alen(laArray, 2)
for lnRow = 1 to lnRows
	for lnCol = 1 to lnCols
		?? laArray[lnRow, lnCol], ' '
	next lnCol
	?
next lnRow

* Clean up before we exit.

oRS.Close()
oConn.Close()
return

******************
function FlipArray
******************

* Flips an array from column-major order to row-major order.

lparameters taArray
local laArray[1], ;
	lnRows, ;
	lnCols, ;
	lnRow, ;
	lnCol
lnRows = alen(taArray, 2)
lnCols = alen(taArray, 1)
dimension laArray[lnRows, lnCols]
for lnRow = 1 to lnRows
	for lnCol = 1 to lnCols
      laArray[lnRow, lnCol] = taArray[lnCol, lnRow]
	next lnCol
next lnRow
dimension taArray[lnRows, lnCols]
acopy(laArray, taArray)
return
